import java.awt.*;

public class ExtentionWarship {
    private static final char _separatorForObject=':';

    public static DrawingWarship CreateDrawingWarship(String info){
        String[] strs = info.split(Character.toString(_separatorForObject));

        int spd=Integer.parseInt(strs[0]);
        float wght = Float.parseFloat(strs[1]);
        Color bodyClr=new Color(Integer.parseInt(strs[2]));
        IDrawingObjectBlock block = switch(strs[3]) {
            case "DrawingBlock" -> new DrawingBlock(Integer.parseInt(strs[4]));
            case "DrawingRoundBlocks" -> new DrawingRoundBlocks(Integer.parseInt(strs[4]));
            case "DrawingTriangleBlocks" -> new DrawingTriangleBlocks(Integer.parseInt(strs[4]));
            default -> null;
        };
        if (strs.length==5){
            EntityWarship ent=new EntityWarship(spd,wght,bodyClr);
            return new DrawingWarship(ent,block);
        }
        if(strs.length==9){
            Color dopClr=new Color(Integer.parseInt(strs[5]));
            boolean ant=Boolean.parseBoolean(strs[6]);
            boolean hlpd=Boolean.parseBoolean(strs[7]);
            boolean msl=Boolean.parseBoolean(strs[8]);
            EntityAdvancedWarship ent = new EntityAdvancedWarship(spd,wght,bodyClr,dopClr,hlpd,ant,msl);
            return new DrawingAdvancedWarship(ent,block);
        }
        return null;
    }

    public static String GetDataForSave(DrawingWarship drawingWarship){
        var warship = drawingWarship.Warship;
        var str = ""+warship.GetSpeed()+_separatorForObject+warship.GetWeight()+_separatorForObject+warship.GetBodyColor().getRGB()+_separatorForObject+drawingWarship.GetBlocks().getClass().getSimpleName()+_separatorForObject+drawingWarship.GetBlocks().GetCount();
        if(!(warship instanceof EntityAdvancedWarship adv)){
            return str;
        }
        return str+_separatorForObject+adv.GetDopColor().getRGB()+_separatorForObject+adv.GetAntenna()+_separatorForObject+adv.GetHelipad()+_separatorForObject+adv.GetMissile();
    }
}
